package edu.georgetown.gucs.fingerprinter;

import edu.georgetown.gucs.dictionary.Dictionary;
import edu.georgetown.gucs.utility.Global;
import edu.georgetown.gucs.utility.ObjectBuilder;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.LinkedBlockingQueue;

/**
 * @author Evan B.
 * @since 11/13/14.
 */
public class BulkFingerprinterWorker implements Callable<List<Fingerprint>> {
    Fingerprinter fingerprinter;
    LinkedBlockingQueue<File> fileLister = new LinkedBlockingQueue<>();
    Dictionary dict;
    String fing;

    List<Fingerprint> fingerprintList = new ArrayList<>();

    BulkFingerprinterWorker(String fingerprinter,
                               Dictionary dict,
                               LinkedBlockingQueue<File> fileLister) {

        //    Global.debug("IncomingLister", fileLister.size());

        this.fileLister.addAll(fileLister);

        this.fing = fingerprinter;

        this.fingerprinter = (Fingerprinter) ObjectBuilder.buildObject(fingerprinter);
        this.fingerprinter.setDictionary(dict);

    }

    @Override
    public List<Fingerprint> call() throws Exception {

        int i = 0;
        while (fileLister.size() > 0) {


            //          Global.debug("InitialFileLister", fileLister.size());

            List<Fingerprint> fp = fingerprinter.computeFingerprint(fileLister.
                    take().getAbsolutePath());

           // Global.debug("Fing", fp.get(0).getFileName() + " " + i);
            fingerprintList.add(fp.get(0));
            i++;
        }

        Global.debug("FingerprintListSize", fingerprintList.size());
        return fingerprintList;

    }
}

